-- This file is part of the reachability analysis tool LaRA
-- (Lazy Reachability Analyzer)
--
-- Loïg Jezequel & Didier Lime
--
-- University of Nantes, École Centrale de Nantes, All rights reserved, 2016


module Main (main) where

import Debug.Trace
import Data.List (foldl1')
import Data.Maybe (fromJust, isNothing)
import qualified Data.Map as M

import System.Environment

import qualified Data.Set as S

import Lara.Data
import Lara.Parser
import Lara.PReach

main =
   do
      automaton <- fmap head getArgs >>= readFile
      case parseA automaton of
         (Left err) -> print err
         (Right e)  -> do 
            putStrLn "Parsing done."
            -- putStrLn $ show e
            -- putStrLn $ show $ zip [0..] $ labels e
            -- putStrLn $ show $ lnReqs e
            -- putStrLn $ concatMap ( (++"\n---\n") . showAuto e) (automata e) ++ "\n====================================\n"
                                  
            -- putStrLn "========================================================================"
            -- putStrLn $ showAuto e a
            let g = preachFull e
            if isNothing g then putStrLn "False"
                           else -- putStrLn "True" 
                                -- for experiments, only True was printed
                                let (Just aut) = g in 
                                    do 
                                       mapM_ (putStrLn.(++"\n") . showAuto e) aut
                                       putStrLn "Trace:"
                                       mapM_ (putStrLn.(++"\n"). showAuto e .fromJust.computeTrace) aut



